dnl aclocal.m4 generated automatically by aclocal 1.4

dnl Copyright (C) 1994, 1995-8, 1999 Free Software Foundation, Inc.
dnl This file is free software; the Free Software Foundation
dnl gives unlimited permission to copy and/or distribute it,
dnl with or without modifications, as long as this notice is preserved.

dnl This program is distributed in the hope that it will be useful,
dnl but WITHOUT ANY WARRANTY, to the extent permitted by law; without
dnl even the implied warranty of MERCHANTABILITY or FITNESS FOR A
dnl PARTICULAR PURPOSE.

dnl
dnl Miscellaneous functions
dnl

dnl *****************************************************************
dnl * Save compiler flags
dnl *****************************************************************


AC_DEFUN(IMPULSE_PARAMS_SAVE,
[
  IMPULSE_SAVE_CFLAGS="$CFLAGS"
  IMPULSE_SAVE_LIBS="$LIBS"
  IMPULSE_SAVE_LDFLAGS="$LDFLAGS"
])


dnl *****************************************************************
dnl * Restore compiler flags
dnl *****************************************************************


AC_DEFUN(IMPULSE_PARAMS_RESTORE,
[
  CFLAGS="$IMPULSE_SAVE_CFLAGS"
  LIBS="$IMPULSE_SAVE_LIBS"
  LDFLAGS="$IMPULSE_SAVE_LDFLAGS"
])


dnl *****************************************************************
dnl * Display a config section header
dnl *****************************************************************


AC_DEFUN(IMPULSE_MSG_SECTION,
[
  AC_MSG_RESULT([])
  AC_MSG_RESULT([------ $1 ------])
  AC_MSG_RESULT([])
])


dnl *****************************************************************
dnl * Display a standard message
dnl *****************************************************************


AC_DEFUN(IMPULSE_ECHO,
[
  AC_MSG_RESULT(["[$1]"])
])


dnl End of file

# Do all the work for Automake.  This macro actually does too much --
# some checks are only needed if your package does certain things.
# But this isn't really a big deal.

# serial 1

dnl Usage:
dnl AM_INIT_AUTOMAKE(package,version, [no-define])

AC_DEFUN(AM_INIT_AUTOMAKE,
[AC_REQUIRE([AC_PROG_INSTALL])
PACKAGE=[$1]
AC_SUBST(PACKAGE)
VERSION=[$2]
AC_SUBST(VERSION)
dnl test to see if srcdir already configured
if test "`cd $srcdir && pwd`" != "`pwd`" && test -f $srcdir/config.status; then
  AC_MSG_ERROR([source directory already configured; run "make distclean" there first])
fi
ifelse([$3],,
AC_DEFINE_UNQUOTED(PACKAGE, "$PACKAGE", [Name of package])
AC_DEFINE_UNQUOTED(VERSION, "$VERSION", [Version number of package]))
AC_REQUIRE([AM_SANITY_CHECK])
AC_REQUIRE([AC_ARG_PROGRAM])
dnl FIXME This is truly gross.
missing_dir=`cd $ac_aux_dir && pwd`
AM_MISSING_PROG(ACLOCAL, aclocal, $missing_dir)
AM_MISSING_PROG(AUTOCONF, autoconf, $missing_dir)
AM_MISSING_PROG(AUTOMAKE, automake, $missing_dir)
AM_MISSING_PROG(AUTOHEADER, autoheader, $missing_dir)
AM_MISSING_PROG(MAKEINFO, makeinfo, $missing_dir)
AC_REQUIRE([AC_PROG_MAKE_SET])])

#
# Check to make sure that the build environment is sane.
#

AC_DEFUN(AM_SANITY_CHECK,
[AC_MSG_CHECKING([whether build environment is sane])
# Just in case
sleep 1
echo timestamp > conftestfile
# Do `set' in a subshell so we don't clobber the current shell's
# arguments.  Must try -L first in case configure is actually a
# symlink; some systems play weird games with the mod time of symlinks
# (eg FreeBSD returns the mod time of the symlink's containing
# directory).
if (
   set X `ls -Lt $srcdir/configure conftestfile 2> /dev/null`
   if test "[$]*" = "X"; then
      # -L didn't work.
      set X `ls -t $srcdir/configure conftestfile`
   fi
   if test "[$]*" != "X $srcdir/configure conftestfile" \
      && test "[$]*" != "X conftestfile $srcdir/configure"; then

      # If neither matched, then we have a broken ls.  This can happen
      # if, for instance, CONFIG_SHELL is bash and it inherits a
      # broken ls alias from the environment.  This has actually
      # happened.  Such a system could not be considered "sane".
      AC_MSG_ERROR([ls -t appears to fail.  Make sure there is not a broken
alias in your environment])
   fi

   test "[$]2" = conftestfile
   )
then
   # Ok.
   :
else
   AC_MSG_ERROR([newly created file is older than distributed files!
Check your system clock])
fi
rm -f conftest*
AC_MSG_RESULT(yes)])

dnl AM_MISSING_PROG(NAME, PROGRAM, DIRECTORY)
dnl The program must properly implement --version.
AC_DEFUN(AM_MISSING_PROG,
[AC_MSG_CHECKING(for working $2)
# Run test in a subshell; some versions of sh will print an error if
# an executable is not found, even if stderr is redirected.
# Redirect stdin to placate older versions of autoconf.  Sigh.
if ($2 --version) < /dev/null > /dev/null 2>&1; then
   $1=$2
   AC_MSG_RESULT(found)
else
   $1="$3/missing $2"
   AC_MSG_RESULT(missing)
fi
AC_SUBST($1)])

# Like AC_CONFIG_HEADER, but automatically create stamp file.

AC_DEFUN(AM_CONFIG_HEADER,
[AC_PREREQ([2.12])
AC_CONFIG_HEADER([$1])
dnl When config.status generates a header, we must update the stamp-h file.
dnl This file resides in the same directory as the config header
dnl that is generated.  We must strip everything past the first ":",
dnl and everything past the last "/".
AC_OUTPUT_COMMANDS(changequote(<<,>>)dnl
ifelse(patsubst(<<$1>>, <<[^ ]>>, <<>>), <<>>,
<<test -z "<<$>>CONFIG_HEADERS" || echo timestamp > patsubst(<<$1>>, <<^\([^:]*/\)?.*>>, <<\1>>)stamp-h<<>>dnl>>,
<<am_indx=1
for am_file in <<$1>>; do
  case " <<$>>CONFIG_HEADERS " in
  *" <<$>>am_file "*<<)>>
    echo timestamp > `echo <<$>>am_file | sed -e 's%:.*%%' -e 's%[^/]*$%%'`stamp-h$am_indx
    ;;
  esac
  am_indx=`expr "<<$>>am_indx" + 1`
done<<>>dnl>>)
changequote([,]))])

dnl
dnl Core functions
dnl

dnl *****************************************************************
dnl * Initialise core configuration information
dnl *****************************************************************


AC_DEFUN(IMPULSE_CORE_INIT,
[
  DEBUG=0
  AC_ARG_ENABLE(debug, [  --enable-debug          Enable debugging output],
  [
    if test "$enableval" = yes; then
      DEBUG=1
    fi
  ])
])


dnl *****************************************************************
dnl * Check for core functionality
dnl *****************************************************************

AC_DEFUN(IMPULSE_CORE_CHECK,
[
  IMPULSE_MSG_SECTION([Checking core functionality])

  GLOBAL_CFLAGS="-D_POSIX_C_SOURCE=199506L -D_XOPEN_SOURCE=500"

  IMPULSE_CORE_CHECK_PROGRAMS
  IMPULSE_CORE_CHECK_HEADERS
  IMPULSE_CORE_CHECK_DEBUG

  CORE_CFLAGS="$CFLAGS $CORE_CFLAGS"
  CORE_LIBS="$LIBS $CORE_LIBS"
  CORE_LDFLAGS="$LDFLAGS $CORE_LDFLAGS"

  AC_CYGWIN
])


dnl *****************************************************************
dnl * Check for a few programs which we need
dnl *****************************************************************


AC_DEFUN(IMPULSE_CORE_CHECK_PROGRAMS,
[
  AC_PATH_PROG(PERL, perl)
  dnl These seem to be checked by libtool anyway
dnl  AC_PROG_INSTALL
dnl  AC_PROG_CC
  AC_PROG_CPP
dnl  AC_PROG_LN_S
dnl  AC_PROG_MAKE_SET
dnl  AC_PROG_RANLIB
  
  AC_PROG_YACC
  AM_PROG_LEX
])


dnl *****************************************************************
dnl * Check for a few more header files which we need
dnl *****************************************************************


AC_DEFUN(IMPULSE_CORE_CHECK_HEADERS,
[
  AC_HEADER_STDC
  AC_CHECK_HEADER(unistd.h,,AC_MSG_ERROR([ROWS needs a working unistd.h to compile]))
  AC_CHECK_HEADER(time.h,,AC_MSG_ERROR([ROWS needs a working time.h to compile]))
  AC_CHECK_HEADER(math.h,,AC_MSG_ERROR([ROWS needs a working math.h to compile]))

  AC_CHECK_LIB(m, pow)
])



dnl *****************************************************************
dnl * Check for a memory corruption checking version of malloc
dnl *****************************************************************


AC_DEFUN(IMPULSE_CORE_CHECK_DEBUG,
[
  IMPULSE_PARAMS_SAVE
  
  AC_CHECK_HEADER(mcheck.h,
  [
    AC_CACHE_CHECK([for mcheck], impulse_cv_mcheck,
    [
      AC_TRY_COMPILE([
        #include <mcheck.h>
        #include <stdlib.h>
      ],[
        mcheck(NULL);
      ],[
        AC_TRY_LINK([
          #include <mcheck.h>
          #include <stdlib.h>
        ],[
          mcheck(NULL);
        ],[
          impulse_cv_mcheck="yes"
        ],[
          impulse_cv_mcheck="no"
        ])
      ],[
        impulse_cv_mcheck="no"
      ])
    ])
    
    if test "$impulse_cv_mcheck" = "yes" ; then
      AC_DEFINE(HAVE_DEBUG_MCHECK, 1)
    fi
  ])
  
  AC_PATH_PROG(GDB, gdb, "none")
  if test "$GDB" != "none" ; then
    AC_DEFINE(HAVE_DEBUG_GDB, 1)
  fi

  
  IMPULSE_PARAMS_RESTORE
])


dnl *****************************************************************
dnl * Finish up configuration
dnl *****************************************************************

AC_DEFUN(IMPULSE_CORE_FINISH,
[
  COMMON_CFLAGS="$COMMON_CFLAGS -DPREFIX_DIR=\"\\\"$prefix\\\"\" -Wall"
  
  if test "$DEBUG" = "1" ; then
    COMMON_CFLAGS="$COMMON_CFLAGS -DDEBUG"
  fi

  if test "$CYGWIN" = "yes" ; then
    COMMON_CFLAGS="$COMMON_CFLAGS -mwindows"
  fi

  AC_SUBST(COMMON_CFLAGS)
  AC_SUBST(GLOBAL_CFLAGS)
  
  AC_SUBST(CORE_CFLAGS)
  AC_SUBST(CORE_LDFLAGS)
  AC_SUBST(CORE_LIBS)
])


dnl *****************************************************************
dnl * Check for a few programs which we need
dnl *****************************************************************

AC_DEFUN(IMPULSE_CORE_SUMMARY,
[
  IMPULSE_ECHO([============ ROWS Configuration Summary ==============])
  IMPULSE_ECHO([])
  IMPULSE_ECHO([ Installation prefix : $prefix])
])
	

dnl End of file


dnl AM_PROG_LEX
dnl Look for flex, lex or missing, then run AC_PROG_LEX and AC_DECL_YYTEXT
AC_DEFUN(AM_PROG_LEX,
[missing_dir=ifelse([$1],,`cd $ac_aux_dir && pwd`,$1)
AC_CHECK_PROGS(LEX, flex lex, "$missing_dir/missing flex")
AC_PROG_LEX
AC_DECL_YYTEXT])

dnl
dnl Check out compiler types
dnl

dnl *****************************************************************
dnl * Finish up configuration
dnl *****************************************************************

AC_DEFUN(IMPULSE_TYPE_INIT,
[
  BYTE_TYPE="int8_t"
  UBYTE_TYPE="uint8_t"
  
  SHORT_TYPE="int16_t"
  USHORT_TYPE="uint16_t"
  
  INT_TYPE="int32_t"
  UINT_TYPE="uint32_t"
  
  LONG_TYPE="int64_t"
  ULONG_TYPE="uint64_t"
  
  BYTE_MIN="INT8_MIN"
  BYTE_MAX="INT8_MAX"
  UBYTE_MAX="UINT8_MAX"
 
  SHORT_MIN="INT16_MIN"
  SHORT_MAX="INT16_MAX"
  USHORT_MAX="UINT16_MAX"

  INT_MIN="INT32_MIN"
  INT_MAX="INT32_MAX"
  UINT_MAX="UINT32_MAX"
  
  LONG_MIN="INT64_MIN"
  LONG_MAX="INT64_MAX"
  ULONG_MAX="UINT64_MAX"
  
  IMPULSE_TYPES_INCLUDE=""
  
  IMPULSE_CONST=""
  IMPULSE_INLINE=""
  IMPULSE_ENDIAN=""
])

dnl *****************************************************************
dnl * Finish up configuration
dnl *****************************************************************


AC_DEFUN(IMPULSE_TYPE_CHECK,
[
  IMPULSE_MSG_SECTION([Checking compiler characteristics])
  IMPULSE_PARAMS_SAVE
  
  AC_TYPE_SIZE_T
  AC_C_CONST
  AC_C_BIGENDIAN
  AC_C_INLINE
  
  case "$ac_cv_c_inline" in
    inline | yes) IMPULSE_INLINE="inline";;
    no) IMPULSE_INLINE="" ;;
    *)  IMPULSE_INLINE="$ac_cv_c_inline";;
  esac

  if test "$ac_cv_c_const" = "yes" ; then
    IMPULSE_CONST="const"
  else
    IMPULSE_CONST=""
  fi

  if test "$ac_cv_c_bigendian" = "yes" ; then
    IMPULSE_ENDIAN="1234"
  else
    IMPULSE_ENDIAN="4321"
  fi

  dnl Long doubles are just too damn f**ked up to use reliably
  dnl Gcc claims it is a 12 byte type, yet certain 80387 instructions
  dnl used for manipulating them only move 10 bytes - Grrr..
  dnl As for Sparcs.... - don't get me started on that
  dnl
  dnl AC_C_LONG_DOUBLE
  
  
  AC_CHECK_HEADER(inttypes.h,
  [
    IMPULSE_TYPES_INCLUDE="#include <inttypes.h>"
  ],[
    AC_CHECK_HEADER(stdint.h,
    [
      IMPULSE_TYPES_INCLUDE="#include <stdint.h>"
    ],[
      # FIXME: there's an alternative to long long in some compilers... what?
  
      AC_CACHE_CHECK([for long long int], impulse_cv_longlong,
      [
        AC_TRY_COMPILE( , long long int foo,
          impulse_cv_longlong="yes",
	  impulse_cv_longlong="no")
      ])
    
  
      # Check sizes of types (make safe-ish assumptions for irritating x-compiles)
      AC_CHECK_SIZEOF(unsigned char, 1)
      AC_CHECK_SIZEOF(short int, 2)
      AC_CHECK_SIZEOF(int,       2)
      AC_CHECK_SIZEOF(long int,  4)
      AC_CHECK_SIZEOF(void *,    8)
      if test "$impulse_cv_longlong" = "yes"; then
        AC_CHECK_SIZEOF(long long int, 8)
      else
        ac_cv_sizeof_long_long_int="0"
      fi
      
      
      # Work out 8, 16, 32, 64 bit values where available
      
      
      BYTE_MIN="(-128)"
      BYTE_MAX="(127)"
      UBYTE_MAX="(255)"
      
      case 1 in
      $ac_cv_sizeof_unsigned_char)
        BYTE_TYPE="signed char"
        UBYTE_TYPE="unsigned char";;
      
      $ac_cv_sizeof_short_int) 
        BYTE_TYPE="signed short int"
        UBYTE_TYPE="unsigned short int";;
      
      *)
        BYTE_TYPE="signed char"
        UBYTE_TYPE="unsigned char";;
      esac
      
      
      SHORT_MIN="(-32767-1)"
      SHORT_MAX="(32767)"
      USHORT_MAX="(65535U)"

      case 2 in
      $ac_cv_sizeof_short_int)
        SHORT_TYPE="signed short int"
        USHORT_TYPE="unsigned short int";;
      
      $ac_cv_sizeof_int)
        SHORT_TYPE="signed int"
        USHORT_TYPE="unsigned int";;
      
      *)
        SHORT_TYPE="signed short int"
        USHORT_TYPE="unsigned short int";;
      esac
      
      
      INT_MIN="(-2147483647-1)"
      INT_MAX="(2147483647)"
      UINT_MAX="(4294967295U)"

      case 4 in
      $ac_cv_sizeof_short_int)
        INT_TYPE="signed short int"
        UINT_TYPE="unsigned short int";;
      
      $ac_cv_sizeof_int)
        INT_TYPE="signed int"
        UINT_TYPE="unsigned int";;
      
      $ac_cv_sizeof_long_int)
        INT_TYPE="signed long int"
        UINT_TYPE="unsigned long int";;
      
      *)
        INT_TYPE="signed int"
        UINT_TYPE="unsigned int";;
      esac
      
      
      LONG_MIN="(-9223372036854775807LL-1)"
      LONG_MAX="(9223372036854775807LL)"
      ULONG_MAX="(18446744073709551615ULL)"
      
      case 8 in
      $ac_cv_sizeof_int)
        LONG_TYPE="signed int"
        ULONG_TYPE="unsigned int";;
      
      $ac_cv_sizeof_long_int)
        LONG_TYPE="signed long int"
        ULONG_TYPE="unsigned long int";;
      
      $ac_cv_sizeof_long_long_int)
        LONG_TYPE="signed long long int"
        ULONG_TYPE="unsigned long long int";;
      
      *)
        LONG_TYPE="signed long int"
        ULONG_TYPE="unsigned long int";;
      esac
      
      IMPULSE_TYPES_INCLUDE=""
    ])
  ])
  
  BOOL_TYPE="impulse_byte"
  CHAR_TYPE="char"
  UNICHAR_TYPE="impulse_ushort"
  
  FLOAT_TYPE="float"
  DOUBLE_TYPE="double"
  
  IMPULSE_PARAMS_RESTORE
])


dnl *****************************************************************
dnl * Finish up configuration
dnl *****************************************************************


AC_DEFUN(IMPULSE_TYPE_FINISH,
[
  AC_SUBST(IMPULSE_TYPES_INCLUDE)
  
  AC_SUBST(BYTE_TYPE)
  AC_SUBST(SHORT_TYPE)
  AC_SUBST(INT_TYPE)
  AC_SUBST(LONG_TYPE)
  
  AC_SUBST(UBYTE_TYPE)
  AC_SUBST(USHORT_TYPE)
  AC_SUBST(UINT_TYPE)
  AC_SUBST(ULONG_TYPE)
  
  AC_SUBST(CHAR_TYPE)
  AC_SUBST(UNICHAR_TYPE)
  AC_SUBST(BOOL_TYPE)
  AC_SUBST(FLOAT_TYPE)
  AC_SUBST(DOUBLE_TYPE)
  
  AC_SUBST(BYTE_MIN)
  AC_SUBST(SHORT_MIN)
  AC_SUBST(INT_MIN)
  AC_SUBST(LONG_MIN)

  AC_SUBST(BYTE_MAX)
  AC_SUBST(SHORT_MAX)
  AC_SUBST(INT_MAX)
  AC_SUBST(LONG_MAX)

  AC_SUBST(UBYTE_MAX)
  AC_SUBST(USHORT_MAX)
  AC_SUBST(UINT_MAX)
  AC_SUBST(ULONG_MAX)

  AC_SUBST(IMPULSE_INLINE)
  AC_SUBST(IMPULSE_CONST)
  AC_SUBST(IMPULSE_ENDIAN)
])


dnl *****************************************************************
dnl * Print configuration summary
dnl *****************************************************************


AC_DEFUN(IMPULSE_TYPE_SUMMARY,
[
  IMPULSE_MSG_SECTION([Compiler characteristics])
  IMPULSE_ECHO(["  8-bit integer: $BYTE_TYPE"])
  IMPULSE_ECHO([" 16-bit integer: $SHORT_TYPE"])
  IMPULSE_ECHO([" 32-bit integer: $INT_TYPE"])
  IMPULSE_ECHO([" 64-bit integer: $LONG_TYPE"])
])

dnl End of file

dnl
dnl Macro to determine which thread library loading subsystem
dnl to use
dnl

dnl *****************************************************************
dnl * Command line arguments for multi-thread support
dnl *****************************************************************

AC_DEFUN(IMPULSE_THREADS_INIT,
[
  AC_ARG_ENABLE([threads],
  [  --enable-threads        Enable the multi-threading interface [default=yes]],
  [
    if test "$enableval" = "yes" ; then
      USE_THREADS="1"
    else
      USE_THREADS="0"
    fi
  ],[
    USE_THREADS="1"
  ])

  AC_ARG_WITH([threads],
  [  --with-threads=[posix/pth/sun/win32]
                          Select the multi-threading interface],
  [
    case $with_threads in
     posix)
       THREADS_PREFERENCE="POSIX";;
       
     sun)
       THREADS_PREFERENCE="SUN";;
       
     win32)
       THREADS_PREFERENCE="WIN32";;
       
     pth)
       THREADS_PREFERENCE="PTH";;
       
     *)
       THREADS_PREFERENCE="NONE";;
   esac
  ],[
    THREADS_PREFERENCE="NONE";
  ])

  IMPULSE_THREADS_INCLUDE2=""
  IMPULSE_THREADS_INCLUDE1=""
  
  IMPULSE_MUTEX_CREATE_STATIC="0"
  IMPULSE_COND_CREATE_STATIC="0"
  IMPULSE_RWLOCK_CREATE_STATIC="0"
  IMPULSE_SEMA_CREATE_STATIC="0"
  
  IMPULSE_THREAD_IMPL="int"
  IMPULSE_MUTEX_IMPL="int"
  IMPULSE_COND_IMPL="int"
  IMPULSE_RWLOCK_IMPL="int"
  IMPULSE_SEMA_IMPL="int"
  
  THREADS_LIBRARY="none"
])



dnl *****************************************************************
dnl * Checking which multi-thread implementation is availble
dnl *****************************************************************

AC_DEFUN(IMPULSE_THREADS_CHECK,
[
  IMPULSE_MSG_SECTION([Checking multi-threading support])
  
  if test "$USE_THREADS" = "1" ; then
    if test "$THREADS_LIBRARY" = "none" ; then
      if test "$THREADS_PREFERENCE" = "NONE" -o "$THREADS_PREFERENCE" = "POSIX" ; then
        IMPULSE_THREADS_CHECK_POSIX
      fi
    fi
    if test "$THREADS_LIBRARY" = "none" ; then
      if test "$THREADS_PREFERENCE" = "NONE" -o "$THREADS_PREFERENCE" = "SUN" ; then
        IMPULSE_THREADS_CHECK_SUN
      fi
    fi
    if test "$THREADS_LIBRARY" = "none" ; then
      if test "$THREADS_PREFERENCE" = "NONE" -o "$THREADS_PREFERENCE" = "WIN32" ; then
        IMPULSE_THREADS_CHECK_WIN32
      fi
    fi
    if test "$THREADS_LIBRARY" = "none" ; then
      if test "$THREADS_PREFERENCE" = "NONE" -o "$THREADS_PREFERENCE" = "PTH" ; then
        IMPULSE_THREADS_CHECK_PTH
      fi
    fi
  
    dnl We still haven't found any, so lets disable threads
    if test "$THREADS_LIBRARY" = "none" ; then
      USE_THREADS="0"
    fi
  fi
  
  if test "$USE_THREADS" = "1" ; then
    GLOBAL_CFLAGS="$GLOBAL_CFLAGS -D_REENTRANT"
  fi
])


dnl *****************************************************************
dnl * Test for basic availability of POSIX threads
dnl *****************************************************************

AC_DEFUN(IMPULSE_THREADS_CHECK_POSIX,
[
  IMPULSE_PARAMS_SAVE
  
  POSIX_LIBS=""
  POSIX_CFLAGS=""
  POSIX_LDFLAGS=""
  CFLAGS="$GLOBAL_CFLAGS $CORE_CFLAGS $THREADS_CFLAGS"
  LIBS="$CORE_LIBS $THREADS_LIBS"
  LDFLAGS="$CORE_LDFLAGS $THREADS_LDFLAGS"
	    
  AC_CHECK_LIB(pthread, pthread_create,
  [
    AC_CHECK_HEADER(pthread.h,
    [
      AC_CHECK_HEADER(semaphore.h,
      [
        AC_CHECK_LIB(pthread, sem_wait,
	[
	  THREADS_LIBRARY="posix"
	  AC_DEFINE(HAVE_THREADS_POSIX, 1)
	  POSIX_LIBS="-lpthread"
	],[
	  AC_CHECK_LIB(posix4, sem_wait,
	  [
	    THREADS_LIBRARY="posix"
	    AC_DEFINE(HAVE_THREADS_POSIX, 1)
	    POSIX_LIBS="-lpthread -lposix4"
	  ])
	])
      ])
    ])
  ])

  if test "$THREADS_LIBRARY" != "posix"; then
    dnl FreeBSD doesn't use the -lpthread library, but rather has a special
    dnl -pthread option to gcc

    AC_MSG_CHECKING([for -pthread flag to C compiler])
    LDFLAGS="$LDFLAGS -pthread"
    CFLAGS="$CFLAGS -pthread"
    AC_TRY_LINK([
      #include <pthread.h>
    ],
    [
      int i;
      pthread_t thread;
      
      pthread_create(&thread, NULL, NULL, NULL);
    ],
    [
      AC_MSG_RESULT([yes (probably FreeBSD)])
      THREADS_LIBRARY="posix"
      AC_DEFINE(HAVE_THREADS_POSIX, 1)
      POSIX_LDFLAGS="-pthread"
      POSIX_CFLAGS="-pthread"
    ],
    [
      AC_MSG_RESULT(no)
    ])
  fi

  IMPULSE_PARAMS_RESTORE
  if test "$THREADS_LIBRARY" = "posix" ; then
    THREADS_CFLAGS="$THREADS_CFLAGS $POSIX_CFLAGS"
    THREADS_LDFLAGS="$THREADS_LDFLAGS $POSIX_LDFLAGS"
    THREADS_LIBS="$THREADS_LIBS $POSIX_LIBS"
    
    IMPULSE_THREADS_CHECK_POSIX_OPT
  fi
])



dnl *****************************************************************
dnl * Check for GNU pth
dnl *****************************************************************


AC_DEFUN(IMPULSE_THREADS_CHECK_PTH,
[
  IMPULSE_PARAMS_SAVE
  PTH_LIBS=""
  PTH_CFLAGS=""
  PTH_LDFLAGS=""
  
  AC_PATH_PROG(PTH_CONFIG, "pth-config", "no")
  if test "$PTH_CONFIG" != "no" ; then
    PTH_CFLAGS=`$PTH_CONFIG $pth_config_args --cflags`
    PTH_LIBS=`$PTH_CONFIG $pth_config_args --libs`
    PTH_LDFLAGS=`$PTH_CONFIG $pth_config_args --ldflags`

    CFLAGS="$GLOBAL_CFLAGS $CORE_CFLAGS $THREADS_CFLAGS $PTH_CFLAGS"
    LIBS="$CORE_LIBS $THREADS_LIBS $PTH_LIBS"
    LDFLAGS="$CORE_LDFLAGS $THREADS_LDFLAGS $PTH_LDFLAGS"
    
    AC_CACHE_CHECK([for pth], impulse_cv_pth,
    [
      AC_TRY_COMPILE([
        #include <pth.h>
      ],[
        pth_init();
      ],[
        AC_TRY_LINK([
          #include <pth.h>
        ],[
	  pth_init();
	],[
          impulse_cv_pth="yes"
	],[
	  impulse_cv_pth="no"
	])
      ],[
        impulse_cv_pth="no"
      ])
    ])
      
    if test "$impulse_cv_pth" = "yes" ; then
      THREADS_LIBRARY="pth"
      AC_DEFINE(HAVE_THREADS_PTH, 1)
    fi
  fi
  
  IMPULSE_PARAMS_RESTORE
  if test "$THREADS_LIBRARY" = "pth" ; then
    THREADS_CFLAGS="$THREADS_CFLAGS $PTH_CFLAGS"
    THREADS_LDFLAGS="$THREADS_LDFLAGS $PTH_LDFLAGS"
    THREADS_LIBS="$THREADS_LIBS $PTH_LIBS"
    
    IMPULSE_THREADS_INCLUDE1="#include <pth.h>"
    IMPULSE_THREAD_IMPL="pth_t"
    IMPULSE_MUTEX_IMPL="pth_mutex_t"
    IMPULSE_COND_IMPL="pth_cond_t"
    IMPULSE_RWLOCK_IMPL="pth_rwlock_t"
    IMPULSE_SEMA_IMPL="struct _impulse_sema_impl { pth_mutex_t mutex; pth_cond_t cond; impulse_int value; }"
    
    IMPULSE_MUTEX_CREATE_STATIC="PTH_MUTEX_INIT"
    IMPULSE_COND_CREATE_STATIC="PTH_COND_INIT"
    IMPULSE_RWLOCK_CREATE_STATIC="PTH_RWLOCK_INIT"
    IMPULSE_SEMA_CREATE_STATIC="{ PTH_MUTEX_INIT, PTH_COND_INIT, 0 }"
  fi
])


dnl *****************************************************************
dnl * Check for SUN native threads
dnl *****************************************************************


AC_DEFUN(IMPULSE_THREADS_CHECK_SUN,
[
  IMPULSE_PARAMS_SAVE
  SUN_LIBS=""
  SUN_CFLAGS=""
  SUN_LDFLAGS=""
  CFLAGS="$GLOBAL_CFLAGS $CORE_CFLAGS $THREADS_CFLAGS"
  LIBS="$CORE_LIBS $THREADS_LIBS"
  LDFLAGS="$CORE_LDFLAGS $THREADS_LDFLAGS"
      
  AC_CHECK_LIB(thread, thr_create,
  [
    AC_CHECK_HEADER(thread.h,
    [
      AC_CHECK_HEADER(synch.h,
      [
        THREADS_LIBRARY="sun"
	AC_DEFINE(HAVE_THREADS_SUN, 1)
	SUN_LIBS="-lthread"
      ])
    ])
  ])

  IMPULSE_PARAMS_RESTORE
  if test "$THREADS_LIBRARY" = "SUN" ; then
    THREADS_CFLAGS="$THREADS_CFLAGS $SUN_CFLAGS"
    THREADS_LDFLAGS="$THREADS_LDFLAGS $SUN_LDFLAGS"
    THREADS_LIBS="$THREADS_LIBS $SUN_LIBS"
    
    IMPULSE_THREADS_INCLUDE1="#include <thread.h>"
    IMPULSE_THREADS_INCLUDE2="#include <synch.h>"
    IMPULSE_THREAD_IMPL="thread_t"
    IMPULSE_MUTEX_IMPL="mutex_t"
    IMPULSE_COND_IMPL="cond_t"
    IMPULSE_RWLOCK_IMPL="rwlock_t"
    IMPULSE_SEMA_IMPL="sema_t"
    IMPULSE_MUTEX_CREATE_STATIC="DEFAULTMUTEX"
    IMPULSE_COND_CREATE_STATIC="DEFAULTCV"
    IMPULSE_RWLOCK_CREATE_STATIC="DEFAULTRWLOCK"
    IMPULSE_SEMA_CREATE_STATIC="DEFAULTSEMA"
  fi
])


dnl *****************************************************************
dnl * Check for WIN32 native threads
dnl *****************************************************************


AC_DEFUN(IMPULSE_THREADS_CHECK_WIN32,
[
  IMPULSE_PARAMS_SAVE
  WIN32_LIBS=""
  WIN32_CFLAGS=""
  WIN32_LDFLAGS=""
  CFLAGS="$GLOBAL_CFLAGS $CORE_CFLAGS $THREADS_CFLAGS"
  LIBS="$CORE_LIBS $THREADS_LIBS"
  LDFLAGS="$CORE_LDFLAGS $THREADS_LDFLAGS"
	
  AC_CHECK_HEADER(windows.h,
  [
    THREADS_LIBRARY="win32"
    AC_DEFINE(HAVE_THREADS_WIN32)
  ])

  IMPULSE_PARAMS_RESTORE
  if test "$THREADS_LIBRARY" = "WIN32" ; then
    THREADS_CFLAGS="$THREADS_CFLAGS $WIN32_CFLAGS"
    THREADS_LDFLAGS="$THREADS_LDFLAGS $WIN32_LDFLAGS"
    THREADS_LIBS="$THREADS_LIBS $WIN32_LIBS"
    
    IMPULSE_THREADS_INCLUDE1="#include <windows.h>"
    IMPULSE_THREAD_IMPL="HANDLE"
    IMPULSE_MUTEX_IMPL="HANDLE"
    IMPULSE_COND_IMPL="struct _impulse_cond_impl { impulse_int waiters; HANDLE waiters_mutex; HANDLE sema; }"
    IMPULSE_RWLOCK_IMPL="struct _impulse_rwlock_impl { impulse_int counter; impulse_int nreaders; impulse_int nwriters; HANDLE mutex; HANDLE readers; HANDLE writers; }"
    IMPULSE_SEMA_IMPL="HANDLE"
    
    IMPULSE_MUTEX_CREATE_STATIC="0"
    IMPULSE_COND_CREATE_STATIC="{ 0, 0, 0 }"
    IMPULSE_RWLOCK_CREATE_STATIC="{ 0, 0, 0, 0 }"
    IMPULSE_SEMA_CREATE_STATIC="0"
  fi
])


dnl *****************************************************************
dnl * Various optional/non-portable Posix Threads features
dnl *****************************************************************


AC_DEFUN(IMPULSE_THREADS_CHECK_POSIX_OPT,
[
  IMPULSE_PARAMS_SAVE
  CFLAGS="$GLOBAL_CFLAGS $CORE_CFLAGS $THREADS_CFLAGS"
  LDFLAGS="$CORE_LDFLAGS $THREADS_LDFLAGS"
  LIBS="$CORE_LIBS $THREADS_LIBS"

  AC_CHECK_FUNC(pthread_rwlock_init,
  [
    THREADS_POSIX_RWLOCK=1
  ],[
    THREADS_POSIX_RWLOCK=0
  ])


  AC_CACHE_CHECK([for recursive mutexes], impulse_cv_recursivemutex,
  [
    AC_TRY_LINK([
      #include <pthread.h>
    ],[
      pthread_mutexattr_t attr;
      pthread_mutexattr_init(&attr);
      pthread_mutexattr_settype(&attr, PTHREAD_MUTEX_RECURSIVE);
    ],[
      impulse_cv_recursivemutex="yes"
    ],[
      impulse_cv_recursivemutex="no"
    ])
  ])
  
  if test "$impulse_cv_recursivemutex" = "yes" ; then
    THREADS_POSIX_RECURSIVE=1
  else
    THREADS_POSIX_RECURSIVE=0
  fi


  AC_CACHE_CHECK([for errorchecking mutexes], impulse_cv_errorcheckingmutex,
  [
    AC_TRY_LINK([
      #include <pthread.h>
    ],[
      pthread_mutexattr_t attr;
      pthread_mutexattr_init(&attr);
      pthread_mutexattr_settype(&attr, PTHREAD_MUTEX_ERRORCHECK);
    ],[
      impulse_cv_errorcheckingmutex="yes"
    ],[
      impulse_cv_errorcheckingmutex="no"
    ])
  ])

  if test "$impulse_cv_errorcheckingmutex" = "yes" ; then
    THREADS_POSIX_ERRORCHECKING=1
  else
    THREADS_POSIX_ERRORCHECKING=0
  fi

  if test "$THREADS_POSIX_RECURSIVE" = "0" -o "$THREADS_POSIX_ERRORCHECKING" = "0" ; then
    AC_CACHE_CHECK([for linux threads non-portable attributes], impulse_cv_linuxthreads,
    [
      AC_TRY_LINK([
        #include <pthread.h>
      ],[
        pthread_mutexattr_t attr;
        pthread_mutexattr_init(&attr);
        pthread_mutexattr_setkind_np(&attr, PTHREAD_MUTEX_RECURSIVE_NP);
        pthread_mutexattr_setkind_np(&attr, PTHREAD_MUTEX_ERRORCHECK_NP);
      ],[
        impulse_cv_linuxthreads="yes"
      ],[
        impulse_cv_linuxthreads="no"
      ])
    ])

    if test "$impulse_cv_linuxthreads" = "yes" ; then
      THREADS_POSIX_LINUX_NP=1
    else 
      THREADS_POSIX_LINUX_NP=0
    fi
  fi

  if test "$THREADS_POSIX_LINUX_NP" = "1" ; then
    AC_DEFINE(HAVE_THREADS_POSIX_LINUX_NP, 1)
  fi
  if test "$THREADS_POSIX_RECURSIVE" = "1" ; then
    AC_DEFINE(HAVE_THREADS_POSIX_RECURSIVE, 1)
  fi
  if test "$THREADS_POSIX_RWLOCK" = "1" ; then
    AC_DEFINE(HAVE_THREADS_POSIX_RWLOCK, 1)
  fi
  if test "$THREADS_POSIX_ERRORCHECKING" = "1" ; then
    AC_DEFINE(HAVE_THREADS_POSIX_ERRORCHECKING, 1)
  fi
  
  IMPULSE_THREADS_INCLUDE1="#include <pthread.h>"
  IMPULSE_THREADS_INCLUDE2="#include <semaphore.h>"
  IMPULSE_THREAD_IMPL="pthread_t"
  
  if test "$THREADS_POSIX_LINUX_NP" = "0" -a "$THREADS_POSIX_RECURSIVE" = "0" ; then
    IMPULSE_MUTEX_IMPL="struct _impulse_mutex_impl { pthread_mutex_t mutex_native; impulse_bool is_recursive; pthread_mutex_t mutex_recursive; pthread_t locked_by; impulse_int lock_level; }"
    IMPULSE_MUTEX_CREATE_STATIC="{ PTHREAD_MUTEX_INITIALIZER, 0, PTHREAD_MUTEX_INITIALIZER, 0, 0 }"
  else
    IMPULSE_MUTEX_IMPL="pthread_mutex_t"
    IMPULSE_MUTEX_CREATE_STATIC="PTHREAD_MUTEX_INITIALIZER"
  fi
  
  IMPULSE_COND_IMPL="pthread_cond_t"
  IMPULSE_COND_CREATE_STATIC="PTHREAD_COND_INITIALIZER"
  
  if test "$THREADS_POSIX_RWLOCK" = "1" ; then
    IMPULSE_RWLOCK_IMPL="pthread_rwlock_t"
    IMPULSE_RWLOCK_CREATE_STATIC="PTHREAD_RWLOCK_INITIALIZER"
  else
    IMPULSE_RWLOCK_IMPL="struct _impulse_rwlock_impl { pthread_mutex_t mutex; pthread_cond_t notify; impulse_int readlocks; impulse_int writelocks; }"
    IMPULSE_RWLOCK_CREATE_STATIC="{ PTHREAD_MUTEX_INITIALIZER, PTHREAD_COND_INITIALIZER, 0, 0 }"
  fi
  
  IMPULSE_SEMA_IMPL="sem_t *"
  IMPULSE_SEMA_CREATE_STATIC="NULL"
  
  IMPULSE_PARAMS_RESTORE
])


dnl *****************************************************************
dnl * Substitute all the variables we need
dnl *****************************************************************


AC_DEFUN(IMPULSE_THREADS_FINISH,
[
  AC_SUBST(USE_THREADS)
  AC_SUBST(THREADS_CFLAGS)
  AC_SUBST(THREADS_LDFLAGS)
  AC_SUBST(THREADS_LIBS)

  AC_SUBST(IMPULSE_THREADS_INCLUDE1)
  AC_SUBST(IMPULSE_THREADS_INCLUDE2)

  AC_SUBST(IMPULSE_MUTEX_CREATE_STATIC)
  AC_SUBST(IMPULSE_COND_CREATE_STATIC)
  AC_SUBST(IMPULSE_RWLOCK_CREATE_STATIC)
  AC_SUBST(IMPULSE_SEMA_CREATE_STATIC)
  
  AC_SUBST(IMPULSE_THREAD_IMPL)
  AC_SUBST(IMPULSE_MUTEX_IMPL)
  AC_SUBST(IMPULSE_COND_IMPL)
  AC_SUBST(IMPULSE_RWLOCK_IMPL)
  AC_SUBST(IMPULSE_SEMA_IMPL)
])


dnl *****************************************************************
dnl * Print out summary of multi-thread configuration
dnl *****************************************************************


AC_DEFUN(IMPULSE_THREADS_SUMMARY,
[
  IMPULSE_ECHO(["Threads library: $THREADS_LIBRARY"])
])

dnl End of file

dnl 
dnl Macros to determine what signal support is available
dnl


dnl *****************************************************************
dnl * Initialise configuration
dnl *****************************************************************

AC_DEFUN(IMPULSE_SIGNAL_INIT,
[
  SIGNAL_SIGINFO="0"
  SIGINFO_BUG="0"
])


dnl *****************************************************************
dnl * Check signal handling capabilities
dnl *****************************************************************

AC_DEFUN(IMPULSE_SIGNAL_CHECK,
[
  IMPULSE_MSG_SECTION([Checking signal handling])
  
  IMPULSE_SIGNAL_CHECK_SIGINFO
  if test "$USE_THREADS" = "1" -a "$THREAD_LIBRARY" = "POSIX" ; then
    IMPULSE_SIGNAL_CHECK_THREAD
  fi
])


dnl *****************************************************************
dnl * Check to see if siginfo is available
dnl *****************************************************************

AC_DEFUN(IMPULSE_SIGNAL_CHECK_SIGINFO,
[
  IMPULSE_PARAMS_SAVE
  
  AC_CHECK_FUNC(sigqueue,,
    AC_CHECK_LIB(rt, sigqueue,SIGNAL_LIBS="-lrt",
      AC_CHECK_LIB(posix4, sigqueue,SIGNAL_LIBS="-lposix4")))
  
  LIBS="$LIBS $SIGNAL_LIBS"
  
  AC_CACHE_CHECK([for POSIX 1003.1b extra signal information], impulse_cv_siginfo,
  [
    AC_TRY_RUN([
      #include <sys/types.h>
      #include <signal.h>
      #include <unistd.h>
      #include <stdio.h>
      
      void bing(int sig, siginfo_t *info, void *data)
      {
        if (info == NULL)
  	  exit(1);
	  
	if (info->si_value.sival_int == 22)
	  exit(0);

        exit(1);
      }
      
      #define SIGNAL SIGRTMIN+1
      
      int main()
      {
        struct sigaction act, oact;
        int result;
        union sigval value;
      
        sigfillset(&act.sa_mask);
        act.sa_flags     = SA_SIGINFO;
	act.sa_sigaction = bing;
	
	result = sigaction(SIGNAL, &act, &oact);
	
	if (result != 0)
          exit(1);
      
        value.sival_int = 22;
	result = sigqueue(getpid(), SIGNAL, value);
	
	if (result != 0)
	  exit(1);
      
        sleep(10);
	
	exit(1);
      }
    ],[
      impulse_cv_siginfo="yes"
    ],[
      impulse_cv_siginfo="no"
    ],[
      impulse_cv_siginfo="no (guessed for x-compile)"
    ])
  ])

  if test "$impulse_cv_siginfo" = "yes" ; then
    SIGNAL_SIGINFO="1"
  else
    SIGNAL_SIGINFO="0"
  fi

  IMPULSE_PARAMS_RESTORE
])


dnl *****************************************************************
dnl * Check for siginfo linuxthread bug
dnl *****************************************************************

AC_DEFUN(IMPULSE_SIGNAL_CHECK_THREAD,
[
  AC_CACHE_CHECK([for linux threads signal bug], impulse_cv_signalbug,
  [
    AC_TRY_RUN([
      #include <sys/types.h>
      #include <signal.h>
      #include <unistd.h>
      #include <stdio.h>
      
      #define SIGNAL SIGRTMIN+1
      
      void bing(int sig, siginfo_t *info, void *data)
      {
        if (info == NULL)
	  exit(1);
	  
	if (info->si_value.sival_int == 565)
          exit(0);

        exit(0);
      }

      int main()
      {
        struct sigaction act, oact;
	int result;
	union sigval value;
	
	sigfillset(&act.sa_mask);
	act.sa_flags     = SA_SIGINFO;
	act.sa_sigaction = bing;
	
	result = sigaction(SIGNAL, &act, &oact);
	
	if (result != 0)
  	  exit(1);
	
	value.sival_int = 565;
	result = sigqueue(getpid(), SIGNAL, value);
	
	if (result != 0)
	  exit(1);
	
	sleep(10);
	exit(1);
      }
    ],[
      impulse_cv_signalbug="no"
    ],[
      impulse_cv_signalbug="yes"
    ],[
      impulse_cv_signalbug="yes (guessing for x-compile)"
    ])
  ])
  
  if test "$impulse_cv_signalbug" = "no" ; then
    SIGINFO_BUG=0
  else
    SIGINFO_BUG=1
    SIGNAL_SIGINFO=0
  fi
])


dnl *****************************************************************
dnl * Finish up configuration
dnl *****************************************************************

AC_DEFUN(IMPULSE_SIGNAL_FINISH,
[
  if test "$SIGNAL_SIGINFO" = "1" ; then
    AC_DEFINE(HAVE_SIGINFO, 1)
  fi
  AC_SUBST(SIGNAL_CFLAGS)
  AC_SUBST(SIGNAL_LDFLAGS)
  AC_SUBST(SIGNAL_LIBS)
])

dnl *****************************************************************
dnl * Print a configuration summary
dnl *****************************************************************

AC_DEFUN(IMPULSE_SIGNAL_SUMMARY,
[
  if test "$SIGINFO_BUG" = "1" ; then
    IMPULSE_ECHO([Your linux threads library has a fatal siginfo bug])
    IMPULSE_ECHO([Disabling siginfo support])
    IMPULSE_ECHO([Please upgrade to a newer version])
  fi
])

dnl End of file

dnl 
dnl Macros to determine what comms libraries available
dnl


dnl *****************************************************************
dnl * Initialise configuration
dnl *****************************************************************

AC_DEFUN(IMPULSE_COMMS_INIT,
[
  COMMS_MODULES=""
])


dnl *****************************************************************
dnl * Check to see if thread safe versions are available
dnl *****************************************************************

AC_DEFUN(IMPULSE_COMMS_CHECK_SOCK,
[
  IMPULSE_PARAMS_SAVE
  SOCK_FAIL="0"
  
  dnl
  dnl Assume that if this works then we also have setsockopt,
  dnl accept, bind, connect, listen, getsockname, getpeername, etc.
  dnl We might need to test for recv/send separately ??
  dnl
  AC_CHECK_HEADER(sys/socket.h,
  [
    AC_CHECK_FUNC(socket,
    [
    ],[
      AC_CHECK_LIB(socket, socket,
      [
	COMMS_LIBS="$COMMS_LIBS -lsocket"
      ],[
        SOCK_FAIL="1"
      ])
    ])
  ])
  
  dnl
  dnl We assume that if this works then we also have gethostbyname,
  dnl gethostent
  dnl
  if test "$SOCK_FAIL" = "0" ; then
    AC_CHECK_HEADER(netdb.h,
    [
      AC_CHECK_FUNC(gethostbyaddr,
      [
        AC_DEFINE(HAVE_COMMS_SOCK, 1)
        AC_CHECK_FUNC(gethostbyname_r,
        [
          AC_DEFINE(HAVE_COMMS_SOCK_REENTRANT, 1)
        ])
	AC_CHECK_FUNC(getaddrinfo,
        [
          AC_CHECK_FUNC(freeaddrinfo,
          [
            AC_CHECK_FUNC(getnameinfo,
	    [
	      AC_DEFINE(HAVE_COMMS_SOCK_ADDRINFO, 1)
	    ])
	  ])
	])
      ],[
        SOCK_FAIL="1"
      ])
    ])
  fi

  if test "$SOCK_FAIL" = "0" ; then
    AC_CHECK_HEADER(sys/ioctl.h,
    [
      AC_CHECK_FUNC(ioctl,
      [
        AC_TRY_COMPILE(
	[
	#include <sys/ioctl.h>
	],[
          ioctl(0, FIONREAD, 0);
	],[
          AC_DEFINE(HAVE_COMMS_SOCK_NREAD, 1)
        ])
      ])
    ])
    
    COMMS_MODULES="$COMMS_MODULES sockets"
    IMPULSE_COMMS_CHECK_SOCK_PROTO
  fi

  IMPULSE_PARAMS_RESTORE
])


dnl *****************************************************************
dnl * Check to see which protocols are available
dnl *****************************************************************

AC_DEFUN(IMPULSE_COMMS_CHECK_SOCK_PROTO,
[
  IMPULSE_PARAMS_SAVE
  
  AC_CHECK_HEADER(netinet/in.h,
  [
    AC_CACHE_CHECK([for IPv4 sockets], impulse_cv_ipv4,
    [
      AC_TRY_COMPILE([
        #include "netinet/in.h"
        #include "sys/socket.h"
      ],[
        struct sockaddr_in addr;
        socket(PF_INET, 0, 0);
      ],[
        impulse_cv_ipv4="yes"
      ],[
        impulse_cv_ipv4="no"
      ])
    ])
  
    AC_CACHE_CHECK([for IPv6 sockets], impulse_cv_ipv6,
    [
      AC_TRY_COMPILE([
        #include "netinet/in.h"
        #include "sys/socket.h"
      ],[
        struct sockaddr_in6 addr;
        socket(PF_INET6, 0, 0);
      ],[
        impulse_cv_ipv6="yes"
      ],[
        impulse_cv_ipv6="no"
      ])
    ])
  ])

  dnl Check for local
  AC_CHECK_HEADER(sys/un.h,
  [
    AC_CACHE_CHECK([for local domain sockets], impulse_cv_local,
    [
      AC_TRY_COMPILE([
        #include "sys/un.h"
        #include "sys/socket.h"
      ],[
        struct sockaddr_un addr;
        socket(PF_LOCAL, 0, 0);
      ],[
        impulse_cv_local="yes"
      ],[
        impulse_cv_local="no"
      ])
    ])
    AC_CACHE_CHECK([for unix domain sockets], impulse_cv_unix,
    [
      AC_TRY_COMPILE([
        #include "sys/un.h"
	#include "sys/socket.h"
      ],[
        struct sockaddr_un addr;
	socket(PF_UNIX, 0, 0);
      ],[
	impulse_cv_unix="yes"
      ],[
        impulse_cv_unix="no"
      ])
    ])
  ])
  
  if test "$impulse_cv_ipv4" = "yes" ; then
    AC_DEFINE(HAVE_COMMS_SOCK_IPV4, 1)
  fi
  if test "$impulse_cv_ipv6" = "yes" ; then
    AC_DEFINE(HAVE_COMMS_SOCK_IPV6, 1)
  fi
  if test "$impulse_cv_local" = "yes" ; then
    AC_DEFINE(HAVE_COMMS_SOCK_LOCAL, 1)
  fi
  if test "$impulse_cv_unix" = "yes" ; then
    AC_DEFINE(HAVE_COMMS_SOCK_UNIX, 1)
  fi
  IMPULSE_PARAMS_RESTORE
])


dnl *****************************************************************
dnl * Check to see what COMMS libraries are available
dnl *****************************************************************

AC_DEFUN(IMPULSE_COMMS_CHECK,
[
  IMPULSE_MSG_SECTION([Checking communications libraries])
  
  IMPULSE_COMMS_CHECK_SOCK
])



dnl *****************************************************************
dnl * Finish up configuration stuff
dnl *****************************************************************


AC_DEFUN(IMPULSE_COMMS_FINISH,
[
  AC_SUBST(COMMS_CFLAGS)
  AC_SUBST(COMMS_LIBS)
  AC_SUBST(COMMS_LDFLAGS)
])


dnl *****************************************************************
dnl * Print configuration summary
dnl *****************************************************************


AC_DEFUN(IMPULSE_COMMS_SUMMARY,
[
  IMPULSE_ECHO(["Communications modules: $COMMS_MODULES"])
])


dnl End of file

dnl
dnl Macro to determine which dynamic library loading subsystem
dnl to use
dnl

dnl *****************************************************************
dnl * Command line arguments for dynamic module interface
dnl *****************************************************************


AC_DEFUN(IMPULSE_MODULE_INIT,
[
  AC_ARG_WITH([module],
  [  --with-modules=[dl/dld/shl/win32]
                          Select dynamic module interface],
  [
    case $with_module in
     dl)
       MODULE_PREFERENCE="DL";;
      
     shl)
       MODULE_PREFERENCE="SHL";;
	
     win32)
       MODULE_PREFERENCE="WIN32";;
	
     dld)
       MODULE_PREFERENCE="DLD";;
	
     *)
       MODULE_PREFERENCE="NONE";;
    esac
  ],[
    MODULE_PREFERENCE="NONE";
  ])
  
  HAVE_MODULES="0"
  MODULE_LIBRARY="none"
])


dnl *****************************************************************
dnl * Check for dynamic module support
dnl *****************************************************************


AC_DEFUN(IMPULSE_MODULE_CHECK,
[
  IMPULSE_MSG_SECTION([Checking dynamic module support])

  if test "$HAVE_MODULES" = "0" ; then
    if test "$MODULE_PREFERENCE" = "NONE" -o "$MODULE_PREFERENCE" = "DL" ; then
      IMPULSE_MODULE_CHECK_DL
    fi
  fi
  if test "$HAVE_MODULES" = "0" ; then
    if test "$MODULE_PREFERENCE" = "NONE" -o "$MODULE_PREFERENCE" = "SHL" ; then
      IMPULSE_MODULE_CHECK_SHL
    fi
  fi
  if test "$HAVE_MODULES" = "0" ; then
    if test "$MODULE_PREFERENCE" = "NONE" -o "$MODULE_PREFERENCE" = "WIN32" ; then
      IMPULSE_MODULE_CHECK_WIN32
    fi
  fi
  if test "$HAVE_MODULES" = "0" ; then
    if test "$MODULE_PREFERENCE" = "NONE" -o "$MODULE_PREFERENCE" = "DLD" ; then
      IMPULSE_MODULE_CHECK_DLD
    fi
  fi
  
  if test "$HAVE_MODULES" = "1" ; then
    AC_DEFINE(HAVE_MODULES, 1)
  fi
])


dnl *****************************************************************
dnl * Check for dlopen module support
dnl *****************************************************************


AC_DEFUN(IMPULSE_MODULE_CHECK_DL,
[
  IMPULSE_PARAMS_SAVE

  AC_CHECK_FUNC(dlopen,
  [
    AC_CHECK_HEADER(dlfcn.h,
    [
      HAVE_MODULES="1"
      MODULE_LIBRARY="dl"
      AC_DEFINE(HAVE_MODULE_DL, 1)
      
      AC_CHECK_FUNC(dlerror, AC_DEFINE(HAVE_MODULE_DL_DLERROR, 1))
    ])
  ],[
    AC_CHECK_LIB(dl, dlopen,
    [
      AC_CHECK_HEADER(dlfcn.h,
      [
        HAVE_MODULES="1"
	MODULE_LIBRARY="dl"
	AC_DEFINE(HAVE_MODULE_DL, 1)
	MODULE_LIBS="$MODULE_LIBS -ldl"
	
	AC_CHECK_LIB(dl, dlerror, AC_DEFINE(HAVE_MODULE_DL_DLERROR, 1))
      ])
    ])
  ])
  
  IMPULSE_PARAMS_RESTORE
])


dnl *****************************************************************
dnl * Check for HPUX shl dynamic module support
dnl *****************************************************************


AC_DEFUN(IMPULSE_MODULE_CHECK_SHL,
[
  IMPULSE_PARAMS_SAVE
  
  AC_CHECK_LIB(dld, shl_load,
  [
    AC_CHECK_HEADER(dl.h,
    [
      HAVE_MODULES="1"
      MODULE_LIBRARY="shl"
      AC_DEFINE(HAVE_MODULE_SHL, 1)

      MODULE_LIBS="$MODULE_LIBS -ldld"
    ])
  ])
  
  IMPULSE_PARAMS_RESTORE
])



dnl *****************************************************************
dnl * Check for Win32 dynamic module support
dnl *****************************************************************


AC_DEFUN(IMPULSE_MODULE_CHECK_WIN32,
[
  IMPULSE_PARAMS_SAVE

  AC_CHECK_FUNC(LoadLibrary,
  [
    AC_CHECK_HEADER(windows.h, 
    [
      HAVE_MODULES="1"
      MODULE_LIBRARY="win32"
      AC_DEFINE(HAVE_MODULE_WIN32)
    ])
  ])
  
  IMPULSE_PARAMS_RESTORE
])


dnl *****************************************************************
dnl * Check for Dld dynamic module support
dnl *****************************************************************


AC_DEFUN(IMPULSE_MODULE_CHECK_DLD,
[
  IMPULSE_PARAMS_SAVE

  AC_CHECK_LIB(dld, dld_init,
  [
    AC_CHECK_HEADER(dld.h,
    [
      HAVE_MODULES="1"
      MODULE_LIBRARY="dld"
      AC_DEFINE(HAVE_MODULE_DLD)
      MODULE_LIBS="$MODULE_LIBS -ldld"
    ])
  ])
  
  IMPULSE_PARAMS_RESTORE
])


dnl *****************************************************************
dnl * Substitute in all our variables
dnl *****************************************************************


AC_DEFUN(IMPULSE_MODULE_FINISH,
[
  AC_SUBST(MODULE_CFLAGS)
  AC_SUBST(MODULE_LDFLAGS)
  AC_SUBST(MODULE_LIBS)
])


dnl *****************************************************************
dnl * Finish up configuration
dnl *****************************************************************


AC_DEFUN(IMPULSE_MODULE_SUMMARY,
[
  IMPULSE_ECHO(["Modules library: $MODULE_LIBRARY"])
])

dnl End of file

dnl
dnl Check for window system
dnl


dnl *****************************************************************
dnl * Register additional command line args
dnl *****************************************************************



AC_DEFUN(IMPULSE_GUI_INIT,
[
  AC_ARG_WITH([gui],
  [  --with-gui=[xwin/win32] Specify the graphical user interface],
  [
    case $with_gui in
     xwin)
      GUI_PREFERENCE="XWIN";;
      
     win32)
      GUI_PREFERENCE="WIN32";;
      
     *)
      GUI_PREFERENCE="NONE";;
    esac
  ],[
    GUI_PREFERENCE="NONE"
  ])
  
  GUI_XWIN_PROTECT_THREAD=0
  AC_ARG_ENABLE(xhack, [  --enable-xhack          Allow (limited) thread support for non-conformant
                          Xlibs (likely to be unstable) ],
  [
    if test "$enableval" = yes; then
      GUI_XWIN_PROTECT_THREAD=Unknown
    fi
  ])

  AC_ARG_ENABLE(forcexhack, [  --enable-forcexhack     Force the hacky X threading code (for
                          debugging purposes) ],
  [
    if test "$enableval" = yes; then
      GUI_XWIN_PROTECT_THREAD=1
    fi
  ])

  GUI_LIBRARY="none"
])


dnl *****************************************************************
dnl * Determine what gui library to use
dnl *****************************************************************



AC_DEFUN(IMPULSE_GUI_CHECK,
[
  IMPULSE_MSG_SECTION([Checking graphical user interface])

  if test "$GUI_PREFERENCE" = "NONE" -o "$GUI_PREFERENCE" = "XWIN" ; then
    if test "$GUI_LIBRARY" = "none" ; then
      IMPULSE_GUI_CHECK_XWIN
      if test "$USE_THREADS" = "1" -a "$GUI_LIBRARY" = "XWIN" ; then
        IMPULSE_GUI_CHECK_XWIN_THREAD
      fi
      IMPULSE_GUI_CHECK_XWIN_SHM
    fi
  fi

  if test "$GUI_PREFERENCE" = "NONE" -o "$GUI_PREFERENCE" = "WIN32" ; then
    if test "$GUI_LIBRARY" = "none" ; then
      IMPULSE_GUI_CHECK_WIN32
    fi
  fi
])



dnl *****************************************************************
dnl * Check to see X  actually works
dnl *****************************************************************



AC_DEFUN(IMPULSE_GUI_CHECK_XWIN,
[
  IMPULSE_PARAMS_SAVE
  XWIN_CFLAGS=""
  XWIN_LDFLAGS=""
  XWIN_LIBS=""

  AC_PATH_X
  AC_PATH_XTRA
  
  CFLAGS="$GLOBAL_CFLAGS $CORE_CFLAGS $GUI_CFLAGS $X_CFLAGS"
  LIBS="$CORE_LIBS $GUI_LIBS $X_LIBS -lX11 $X_EXTRA_LIBS -lXext"
dnl  LIBS="$CORE_LIBS $GUI_LIBS $X_LIBS $X_PRE_LIBS -lX11 $X_EXTRA_LIBS -lXext"
  LDFLAGS="$CORE_LDFLAGS $GUI_LDFLAGS"

  if test "$no_x" != "yes" ; then
    AC_CHECK_LIB(Xext, XShapeCombineMask,
    [
      LIBS="$LIBS -lXext"
      AC_CACHE_CHECK([for X header files and libraries],impulse_cv_X_ok,
      [
        AC_TRY_LINK(
	[
	  #include <X11/Xlib.h>
	  #include <X11/Xutil.h>
	  #include <X11/extensions/shape.h>
	],[
	  /* We really need to make this function a little more interesting */
	  
	  XOpenDisplay(NULL);
	],[
	  impulse_cv_X_ok="yes"
	],[
	  impulse_cv_X_ok="no"
	])
      ])
	
      if test "$impulse_cv_X_ok" = "yes" ; then
        GUI_LIBRARY="xwin"
        AC_DEFINE(HAVE_GUI_XWIN, 1)
        XWIN_CFLAGS="$X_CFLAGS"
 	XWIN_LIBS="$X_LIBS -lX11 $X_EXTRA_LIBS -lXext"
dnl 	XWIN_LIBS="$X_LIBS $X_PRE_LIBS -lX11 $X_EXTRA_LIBS -lXext"
	XWIN_LDFLAGS=""
      fi
    ])
  
    if test "$impulse_cv_X_ok" = "no" ; then
      AC_MSG_CHECKING(what's wrong)
      FAIL=""
    
      AC_TRY_COMPILE(
      [
        #include <X11/Xlib.h>
      ],,,[
        AC_MSG_RESULT(Can't find Xlib.h)
        FAIL="1"
      ])

      if test "x$FAIL" = "x" ; then
        AC_TRY_COMPILE(
        [
	  #include <X11/Xlib.h>
  	  #include <X11/Xutil.h>
        ],,,[
  	  AC_MSG_RESULT(Can't find Xutil.h)
	  FAIL="1"
	])
      fi
    
      if test "x$FAIL" = "x" ; then
        AC_TRY_COMPILE([
	  #include <X11/Xlib.h>
	  #include <X11/Xutil.h>
	  #include <X11/extensions/shape.h>
	],,,[
	  AC_MSG_RESULT(Can't find extensions/shape.h)
	  FAIL="1"
	])
      fi
      
      if test "x$FAIL" = "x" ; then
        AC_TRY_LINK([
	  #include <X11/Xlib.h>
	  #include <X11/Xutil.h>
	  #include <X11/extensions/shape.h>
	],[
	  /* We really need to make this function a little more interesting */
	  
	  XOpenDisplay(NULL);
	],[
          AC_MSG_RESULT(that's odd - it seems to work now)
	],[
	  AC_MSG_RESULT(doesn't seem to want to link)
        ])
      fi
    fi
  fi
  
  IMPULSE_PARAMS_RESTORE

  if test "$GUI_LIBRARY" = "xwin" ; then
    GUI_CFLAGS="$GUI_CFLAGS $XWIN_CFLAGS"
    GUI_LDFLAGS="$GUI_LDFLAGS $XWIN_LDFLAGS"
    GUI_LIBS="$GUI_LIBS $XWIN_LIBS"
  fi
])


dnl *****************************************************************
dnl * Check to see if Win32 is lying about anywhere
dnl *****************************************************************

AC_DEFUN(IMPULSE_GUI_CHECK_WIN32,
[
  IMPULSE_PARAMS_SAVE

  AC_CHECK_HEADER(windows.h,
  [
    GUI_LIBRARY="win32"
    AC_DEFINE(HAVE_GUI_WIN32, 1)
  ])
  
  IMPULSE_PARAMS_RESTORE
])


dnl *****************************************************************
dnl * Check to see if we can support MIT SHM
dnl *****************************************************************


AC_DEFUN(IMPULSE_GUI_CHECK_XWIN_SHM,
[
  IMPULSE_PARAMS_SAVE

  CFLAGS="$GLOBAL_CFLAGS $CORE_CFLAGS $GUI_CFLAGS $X_CFLAGS"
  LIBS="$CORE_LIBS $GUI_LIBS $X_LIBS -lX11 $X_EXTRA_LIBS -lXext"
  LDFLAGS="$CORE_LDFLAGS $GUI_LDFLAGS"

  AC_CACHE_CHECK([for X shared memory extension support], impulse_cv_xshm, [
    AC_TRY_LINK([
      #include <X11/Xlib.h>
      #include <sys/ipc.h>
      #include <sys/shm.h>
      #include <X11/extensions/XShm.h>
    ], [
      XShmQueryExtension(NULL); /* Not very exciting... */
    ], [
      impulse_cv_xshm="yes"
    ], [
      impulse_cv_xshm="no"
    ])
  ])

  IMPULSE_PARAMS_RESTORE

  if test "$impulse_cv_xshm" = "yes" ; then
    AC_DEFINE(HAVE_XEXT_MIT_SHM, 1)
  fi
])

dnl *****************************************************************
dnl * Check to see if we have a threadsafe XWin
dnl *****************************************************************


AC_DEFUN(IMPULSE_GUI_CHECK_XWIN_THREAD,
[
  IMPULSE_PARAMS_SAVE

  CFLAGS="$GLOBAL_CFLAGS $CORE_CFLAGS $GUI_CFLAGS"
  LDFLAGS="$CORE_LDFLAGS $GUI_LDFLAGS"
  LIBS="$CORE_LIBS $GUI_LIBS"

  AC_CACHE_CHECK([for threadsafe Xlib], impulse_cv_xlibthreads,
  [
    AC_TRY_RUN([
      #include <stdio.h>
      
      #include <X11/Xlib.h>
      #include <X11/Xutil.h>
      
      int main(void)
      {
        Status st;
	
	st = XInitThreads();
	if (st != 0)
  	  return 0;
	return 1;
      }
    ],[
      impulse_cv_xlibthreads="yes"
    ],[
      impulse_cv_xlibthreads="no"
    ],[
      impulse_cv_xlibthreads="no (guessing for x-compile)"
    ])
  ])

  if test "$impulse_cv_xlibthreads" = "no" -a "$THREAD_PROTECT_X" != 0 ; then
    AC_DEFINE(HAVE_GUI_XWIN_PROTECT, 1)
  fi

  IMPULSE_PARAMS_RESTORE
])


dnl *****************************************************************
dnl * Substitute all the variables we need
dnl *****************************************************************


AC_DEFUN(IMPULSE_GUI_FINISH,
[
  AC_SUBST(GUI_CFLAGS)
  AC_SUBST(GUI_LIBS)
  AC_SUBST(GUI_LDFLAGS)
])


dnl *****************************************************************
dnl * Print out a configuration summary
dnl *****************************************************************


AC_DEFUN(IMPULSE_GUI_SUMMARY,
[
  IMPULSE_ECHO(["Graphical user interface: $GUI_LIBRARY"])
])

dnl 
dnl Macros to determine what image libraries available
dnl


dnl *****************************************************************
dnl * Initialise configuration
dnl *****************************************************************

AC_DEFUN(IMPULSE_IMAGE_INIT,
[
])


dnl *****************************************************************
dnl * Check to see if PNG libs are available
dnl *****************************************************************

AC_DEFUN(IMPULSE_IMAGE_CHECK_PNG,
[
  IMPULSE_PARAMS_SAVE

  AC_CHECK_LIB(z, deflate,
  [
    AC_CHECK_LIB(png, png_check_sig,
    [
      PNG_LIBS="$PNG_LIBS -lz -lpng"
      AC_DEFINE(HAVE_IMAGES_PNG, 1)
    ])
  ])

  IMPULSE_PARAMS_RESTORE
])


dnl *****************************************************************
dnl * Check to see if JPEG libraries are available
dnl *****************************************************************

AC_DEFUN(IMPULSE_IMAGE_CHECK_JPEG,
[
  IMPULSE_PARAMS_SAVE

  AC_CHECK_LIB(jpeg, jpeg_CreateCompress,
  [
    JPEG_LIBS="$JPEG_LIBS -ljpeg"
    AC_DEFINE(HAVE_IMAGES_JPEG, 1)
  ])

  IMPULSE_PARAMS_RESTORE
])


dnl *****************************************************************
dnl * Check to see if XPM libraries are available
dnl *****************************************************************

AC_DEFUN(IMPULSE_IMAGE_CHECK_XPM,
[
  IMPULSE_PARAMS_SAVE

  LIBS="$CORE_LIBS $XPM_LIBS $GUI_LIBS"
  LDFLAGS="$CORE_LDFLAGS $XPM_LDFLAGS $GUI_FLAGS"
  CFLAGS="$GLOBAL_CFLAGS $CORE_CFLAGS $XPM_CFLAGS $GUI_CFLAGS"
  
  AC_CHECK_HEADER(X11/xpm.h,
  [
    AC_CHECK_LIB(Xpm, XpmReadFileToPixmap,
    [
      XPM_LIBS="$XPM_LIBS -lXpm"
      AC_DEFINE(HAVE_IMAGES_XPM, 1)
    ])
  ])

  IMPULSE_PARAMS_RESTORE
])


dnl *****************************************************************
dnl * Check to see if TIFF libraries are available
dnl *****************************************************************

AC_DEFUN(IMPULSE_IMAGE_CHECK_TIFF,
[
  IMPULSE_PARAMS_SAVE

  AC_CHECK_HEADER(tiffio.h,
  [
    AC_CHECK_LIB(tiff, TIFFOpen,
    [
      TIFF_LIBS="$TIFF_LIBS -ltiff"
      AC_DEFINE(HAVE_IMAGES_TIFF, 1)
    ])
  ])

  IMPULSE_PARAMS_RESTORE
])


dnl *****************************************************************
dnl * Check to see what image libraries are available
dnl *****************************************************************

AC_DEFUN(IMPULSE_IMAGE_CHECK,
[
  IMPULSE_MSG_SECTION([Checking image libraries])

  IMPULSE_IMAGE_CHECK_PNG
  IMPULSE_IMAGE_CHECK_JPEG
  IMPULSE_IMAGE_CHECK_XPM
  IMPULSE_IMAGE_CHECK_TIFF
])



dnl *****************************************************************
dnl * Finish up configuration stuff
dnl *****************************************************************


AC_DEFUN(IMPULSE_IMAGE_FINISH,
[
  AC_SUBST(PNG_CFLAGS)
  AC_SUBST(PNG_LDFLAGS)
  AC_SUBST(PNG_LIBS)

  AC_SUBST(JPEG_CFLAGS)
  AC_SUBST(JPEG_LDFLAGS)
  AC_SUBST(JPEG_LIBS)

  AC_SUBST(XPM_CFLAGS)
  AC_SUBST(XPM_LDFLAGS)
  AC_SUBST(XPM_LIBS)

  AC_SUBST(TIFF_CFLAGS)
  AC_SUBST(TIFF_LDFLAGS)
  AC_SUBST(TIFF_LIBS)
])


dnl *****************************************************************
dnl * Print configuration summary
dnl *****************************************************************


AC_DEFUN(IMPULSE_IMAGE_SUMMARY,
[
])


dnl End of file


# serial 40 AC_PROG_LIBTOOL
AC_DEFUN(AC_PROG_LIBTOOL,
[AC_REQUIRE([AC_LIBTOOL_SETUP])dnl

# Save cache, so that ltconfig can load it
AC_CACHE_SAVE

# Actually configure libtool.  ac_aux_dir is where install-sh is found.
CC="$CC" CFLAGS="$CFLAGS" CPPFLAGS="$CPPFLAGS" \
LD="$LD" LDFLAGS="$LDFLAGS" LIBS="$LIBS" \
LN_S="$LN_S" NM="$NM" RANLIB="$RANLIB" \
DLLTOOL="$DLLTOOL" AS="$AS" OBJDUMP="$OBJDUMP" \
${CONFIG_SHELL-/bin/sh} $ac_aux_dir/ltconfig --no-reexec \
$libtool_flags --no-verify $ac_aux_dir/ltmain.sh $host \
|| AC_MSG_ERROR([libtool configure failed])

# Reload cache, that may have been modified by ltconfig
AC_CACHE_LOAD

# This can be used to rebuild libtool when needed
LIBTOOL_DEPS="$ac_aux_dir/ltconfig $ac_aux_dir/ltmain.sh"

# Always use our own libtool.
LIBTOOL='$(SHELL) $(top_builddir)/libtool'
AC_SUBST(LIBTOOL)dnl

# Redirect the config.log output again, so that the ltconfig log is not
# clobbered by the next message.
exec 5>>./config.log
])

AC_DEFUN(AC_LIBTOOL_SETUP,
[AC_PREREQ(2.13)dnl
AC_REQUIRE([AC_ENABLE_SHARED])dnl
AC_REQUIRE([AC_ENABLE_STATIC])dnl
AC_REQUIRE([AC_ENABLE_FAST_INSTALL])dnl
AC_REQUIRE([AC_CANONICAL_HOST])dnl
AC_REQUIRE([AC_CANONICAL_BUILD])dnl
AC_REQUIRE([AC_PROG_RANLIB])dnl
AC_REQUIRE([AC_PROG_CC])dnl
AC_REQUIRE([AC_PROG_LD])dnl
AC_REQUIRE([AC_PROG_NM])dnl
AC_REQUIRE([AC_PROG_LN_S])dnl
dnl

# Check for any special flags to pass to ltconfig.
libtool_flags="--cache-file=$cache_file"
test "$enable_shared" = no && libtool_flags="$libtool_flags --disable-shared"
test "$enable_static" = no && libtool_flags="$libtool_flags --disable-static"
test "$enable_fast_install" = no && libtool_flags="$libtool_flags --disable-fast-install"
test "$ac_cv_prog_gcc" = yes && libtool_flags="$libtool_flags --with-gcc"
test "$ac_cv_prog_gnu_ld" = yes && libtool_flags="$libtool_flags --with-gnu-ld"
ifdef([AC_PROVIDE_AC_LIBTOOL_DLOPEN],
[libtool_flags="$libtool_flags --enable-dlopen"])
ifdef([AC_PROVIDE_AC_LIBTOOL_WIN32_DLL],
[libtool_flags="$libtool_flags --enable-win32-dll"])
AC_ARG_ENABLE(libtool-lock,
  [  --disable-libtool-lock  avoid locking (might break parallel builds)])
test "x$enable_libtool_lock" = xno && libtool_flags="$libtool_flags --disable-lock"
test x"$silent" = xyes && libtool_flags="$libtool_flags --silent"

# Some flags need to be propagated to the compiler or linker for good
# libtool support.
case "$host" in
*-*-irix6*)
  # Find out which ABI we are using.
  echo '[#]line __oline__ "configure"' > conftest.$ac_ext
  if AC_TRY_EVAL(ac_compile); then
    case "`/usr/bin/file conftest.o`" in
    *32-bit*)
      LD="${LD-ld} -32"
      ;;
    *N32*)
      LD="${LD-ld} -n32"
      ;;
    *64-bit*)
      LD="${LD-ld} -64"
      ;;
    esac
  fi
  rm -rf conftest*
  ;;

*-*-sco3.2v5*)
  # On SCO OpenServer 5, we need -belf to get full-featured binaries.
  SAVE_CFLAGS="$CFLAGS"
  CFLAGS="$CFLAGS -belf"
  AC_CACHE_CHECK([whether the C compiler needs -belf], lt_cv_cc_needs_belf,
    [AC_TRY_LINK([],[],[lt_cv_cc_needs_belf=yes],[lt_cv_cc_needs_belf=no])])
  if test x"$lt_cv_cc_needs_belf" != x"yes"; then
    # this is probably gcc 2.8.0, egcs 1.0 or newer; no need for -belf
    CFLAGS="$SAVE_CFLAGS"
  fi
  ;;

ifdef([AC_PROVIDE_AC_LIBTOOL_WIN32_DLL],
[*-*-cygwin* | *-*-mingw*)
  AC_CHECK_TOOL(DLLTOOL, dlltool, false)
  AC_CHECK_TOOL(AS, as, false)
  AC_CHECK_TOOL(OBJDUMP, objdump, false)
  ;;
])
esac
])

# AC_LIBTOOL_DLOPEN - enable checks for dlopen support
AC_DEFUN(AC_LIBTOOL_DLOPEN, [AC_BEFORE([$0],[AC_LIBTOOL_SETUP])])

# AC_LIBTOOL_WIN32_DLL - declare package support for building win32 dll's
AC_DEFUN(AC_LIBTOOL_WIN32_DLL, [AC_BEFORE([$0], [AC_LIBTOOL_SETUP])])

# AC_ENABLE_SHARED - implement the --enable-shared flag
# Usage: AC_ENABLE_SHARED[(DEFAULT)]
#   Where DEFAULT is either `yes' or `no'.  If omitted, it defaults to
#   `yes'.
AC_DEFUN(AC_ENABLE_SHARED, [dnl
define([AC_ENABLE_SHARED_DEFAULT], ifelse($1, no, no, yes))dnl
AC_ARG_ENABLE(shared,
changequote(<<, >>)dnl
<<  --enable-shared[=PKGS]  build shared libraries [default=>>AC_ENABLE_SHARED_DEFAULT],
changequote([, ])dnl
[p=${PACKAGE-default}
case "$enableval" in
yes) enable_shared=yes ;;
no) enable_shared=no ;;
*)
  enable_shared=no
  # Look at the argument we got.  We use all the common list separators.
  IFS="${IFS= 	}"; ac_save_ifs="$IFS"; IFS="${IFS}:,"
  for pkg in $enableval; do
    if test "X$pkg" = "X$p"; then
      enable_shared=yes
    fi
  done
  IFS="$ac_save_ifs"
  ;;
esac],
enable_shared=AC_ENABLE_SHARED_DEFAULT)dnl
])

# AC_DISABLE_SHARED - set the default shared flag to --disable-shared
AC_DEFUN(AC_DISABLE_SHARED, [AC_BEFORE([$0],[AC_LIBTOOL_SETUP])dnl
AC_ENABLE_SHARED(no)])

# AC_ENABLE_STATIC - implement the --enable-static flag
# Usage: AC_ENABLE_STATIC[(DEFAULT)]
#   Where DEFAULT is either `yes' or `no'.  If omitted, it defaults to
#   `yes'.
AC_DEFUN(AC_ENABLE_STATIC, [dnl
define([AC_ENABLE_STATIC_DEFAULT], ifelse($1, no, no, yes))dnl
AC_ARG_ENABLE(static,
changequote(<<, >>)dnl
<<  --enable-static[=PKGS]  build static libraries [default=>>AC_ENABLE_STATIC_DEFAULT],
changequote([, ])dnl
[p=${PACKAGE-default}
case "$enableval" in
yes) enable_static=yes ;;
no) enable_static=no ;;
*)
  enable_static=no
  # Look at the argument we got.  We use all the common list separators.
  IFS="${IFS= 	}"; ac_save_ifs="$IFS"; IFS="${IFS}:,"
  for pkg in $enableval; do
    if test "X$pkg" = "X$p"; then
      enable_static=yes
    fi
  done
  IFS="$ac_save_ifs"
  ;;
esac],
enable_static=AC_ENABLE_STATIC_DEFAULT)dnl
])

# AC_DISABLE_STATIC - set the default static flag to --disable-static
AC_DEFUN(AC_DISABLE_STATIC, [AC_BEFORE([$0],[AC_LIBTOOL_SETUP])dnl
AC_ENABLE_STATIC(no)])


# AC_ENABLE_FAST_INSTALL - implement the --enable-fast-install flag
# Usage: AC_ENABLE_FAST_INSTALL[(DEFAULT)]
#   Where DEFAULT is either `yes' or `no'.  If omitted, it defaults to
#   `yes'.
AC_DEFUN(AC_ENABLE_FAST_INSTALL, [dnl
define([AC_ENABLE_FAST_INSTALL_DEFAULT], ifelse($1, no, no, yes))dnl
AC_ARG_ENABLE(fast-install,
changequote(<<, >>)dnl
<<  --enable-fast-install[=PKGS]  optimize for fast installation [default=>>AC_ENABLE_FAST_INSTALL_DEFAULT],
changequote([, ])dnl
[p=${PACKAGE-default}
case "$enableval" in
yes) enable_fast_install=yes ;;
no) enable_fast_install=no ;;
*)
  enable_fast_install=no
  # Look at the argument we got.  We use all the common list separators.
  IFS="${IFS= 	}"; ac_save_ifs="$IFS"; IFS="${IFS}:,"
  for pkg in $enableval; do
    if test "X$pkg" = "X$p"; then
      enable_fast_install=yes
    fi
  done
  IFS="$ac_save_ifs"
  ;;
esac],
enable_fast_install=AC_ENABLE_FAST_INSTALL_DEFAULT)dnl
])

# AC_ENABLE_FAST_INSTALL - set the default to --disable-fast-install
AC_DEFUN(AC_DISABLE_FAST_INSTALL, [AC_BEFORE([$0],[AC_LIBTOOL_SETUP])dnl
AC_ENABLE_FAST_INSTALL(no)])

# AC_PROG_LD - find the path to the GNU or non-GNU linker
AC_DEFUN(AC_PROG_LD,
[AC_ARG_WITH(gnu-ld,
[  --with-gnu-ld           assume the C compiler uses GNU ld [default=no]],
test "$withval" = no || with_gnu_ld=yes, with_gnu_ld=no)
AC_REQUIRE([AC_PROG_CC])dnl
AC_REQUIRE([AC_CANONICAL_HOST])dnl
AC_REQUIRE([AC_CANONICAL_BUILD])dnl
ac_prog=ld
if test "$ac_cv_prog_gcc" = yes; then
  # Check if gcc -print-prog-name=ld gives a path.
  AC_MSG_CHECKING([for ld used by GCC])
  ac_prog=`($CC -print-prog-name=ld) 2>&5`
  case "$ac_prog" in
    # Accept absolute paths.
changequote(,)dnl
    [\\/]* | [A-Za-z]:[\\/]*)
      re_direlt='/[^/][^/]*/\.\./'
changequote([,])dnl
      # Canonicalize the path of ld
      ac_prog=`echo $ac_prog| sed 's%\\\\%/%g'`
      while echo $ac_prog | grep "$re_direlt" > /dev/null 2>&1; do
	ac_prog=`echo $ac_prog| sed "s%$re_direlt%/%"`
      done
      test -z "$LD" && LD="$ac_prog"
      ;;
  "")
    # If it fails, then pretend we aren't using GCC.
    ac_prog=ld
    ;;
  *)
    # If it is relative, then search for the first ld in PATH.
    with_gnu_ld=unknown
    ;;
  esac
elif test "$with_gnu_ld" = yes; then
  AC_MSG_CHECKING([for GNU ld])
else
  AC_MSG_CHECKING([for non-GNU ld])
fi
AC_CACHE_VAL(ac_cv_path_LD,
[if test -z "$LD"; then
  IFS="${IFS= 	}"; ac_save_ifs="$IFS"; IFS="${IFS}${PATH_SEPARATOR-:}"
  for ac_dir in $PATH; do
    test -z "$ac_dir" && ac_dir=.
    if test -f "$ac_dir/$ac_prog" || test -f "$ac_dir/$ac_prog$ac_exeext"; then
      ac_cv_path_LD="$ac_dir/$ac_prog"
      # Check to see if the program is GNU ld.  I'd rather use --version,
      # but apparently some GNU ld's only accept -v.
      # Break only if it was the GNU/non-GNU ld that we prefer.
      if "$ac_cv_path_LD" -v 2>&1 < /dev/null | egrep '(GNU|with BFD)' > /dev/null; then
	test "$with_gnu_ld" != no && break
      else
	test "$with_gnu_ld" != yes && break
      fi
    fi
  done
  IFS="$ac_save_ifs"
else
  ac_cv_path_LD="$LD" # Let the user override the test with a path.
fi])
LD="$ac_cv_path_LD"
if test -n "$LD"; then
  AC_MSG_RESULT($LD)
else
  AC_MSG_RESULT(no)
fi
test -z "$LD" && AC_MSG_ERROR([no acceptable ld found in \$PATH])
AC_SUBST(LD)
AC_PROG_LD_GNU
])

AC_DEFUN(AC_PROG_LD_GNU,
[AC_CACHE_CHECK([if the linker ($LD) is GNU ld], ac_cv_prog_gnu_ld,
[# I'd rather use --version here, but apparently some GNU ld's only accept -v.
if $LD -v 2>&1 </dev/null | egrep '(GNU|with BFD)' 1>&5; then
  ac_cv_prog_gnu_ld=yes
else
  ac_cv_prog_gnu_ld=no
fi])
])

# AC_PROG_NM - find the path to a BSD-compatible name lister
AC_DEFUN(AC_PROG_NM,
[AC_MSG_CHECKING([for BSD-compatible nm])
AC_CACHE_VAL(ac_cv_path_NM,
[if test -n "$NM"; then
  # Let the user override the test.
  ac_cv_path_NM="$NM"
else
  IFS="${IFS= 	}"; ac_save_ifs="$IFS"; IFS="${IFS}${PATH_SEPARATOR-:}"
  for ac_dir in $PATH /usr/ccs/bin /usr/ucb /bin; do
    test -z "$ac_dir" && ac_dir=.
    if test -f $ac_dir/nm || test -f $ac_dir/nm$ac_exeext ; then
      # Check to see if the nm accepts a BSD-compat flag.
      # Adding the `sed 1q' prevents false positives on HP-UX, which says:
      #   nm: unknown option "B" ignored
      if ($ac_dir/nm -B /dev/null 2>&1 | sed '1q'; exit 0) | egrep /dev/null >/dev/null; then
	ac_cv_path_NM="$ac_dir/nm -B"
	break
      elif ($ac_dir/nm -p /dev/null 2>&1 | sed '1q'; exit 0) | egrep /dev/null >/dev/null; then
	ac_cv_path_NM="$ac_dir/nm -p"
	break
      else
	ac_cv_path_NM=${ac_cv_path_NM="$ac_dir/nm"} # keep the first match, but
	continue # so that we can try to find one that supports BSD flags
      fi
    fi
  done
  IFS="$ac_save_ifs"
  test -z "$ac_cv_path_NM" && ac_cv_path_NM=nm
fi])
NM="$ac_cv_path_NM"
AC_MSG_RESULT([$NM])
AC_SUBST(NM)
])

# AC_CHECK_LIBM - check for math library
AC_DEFUN(AC_CHECK_LIBM,
[AC_REQUIRE([AC_CANONICAL_HOST])dnl
LIBM=
case "$host" in
*-*-beos* | *-*-cygwin*)
  # These system don't have libm
  ;;
*-ncr-sysv4.3*)
  AC_CHECK_LIB(mw, _mwvalidcheckl, LIBM="-lmw")
  AC_CHECK_LIB(m, main, LIBM="$LIBM -lm")
  ;;
*)
  AC_CHECK_LIB(m, main, LIBM="-lm")
  ;;
esac
])

# AC_LIBLTDL_CONVENIENCE[(dir)] - sets LIBLTDL to the link flags for
# the libltdl convenience library, adds --enable-ltdl-convenience to
# the configure arguments.  Note that LIBLTDL is not AC_SUBSTed, nor
# is AC_CONFIG_SUBDIRS called.  If DIR is not provided, it is assumed
# to be `${top_builddir}/libltdl'.  Make sure you start DIR with
# '${top_builddir}/' (note the single quotes!) if your package is not
# flat, and, if you're not using automake, define top_builddir as
# appropriate in the Makefiles.
AC_DEFUN(AC_LIBLTDL_CONVENIENCE, [AC_BEFORE([$0],[AC_LIBTOOL_SETUP])dnl
  case "$enable_ltdl_convenience" in
  no) AC_MSG_ERROR([this package needs a convenience libltdl]) ;;
  "") enable_ltdl_convenience=yes
      ac_configure_args="$ac_configure_args --enable-ltdl-convenience" ;;
  esac
  LIBLTDL=ifelse($#,1,$1,['${top_builddir}/libltdl'])/libltdlc.la
  INCLTDL=ifelse($#,1,-I$1,['-I${top_builddir}/libltdl'])
])

# AC_LIBLTDL_INSTALLABLE[(dir)] - sets LIBLTDL to the link flags for
# the libltdl installable library, and adds --enable-ltdl-install to
# the configure arguments.  Note that LIBLTDL is not AC_SUBSTed, nor
# is AC_CONFIG_SUBDIRS called.  If DIR is not provided, it is assumed
# to be `${top_builddir}/libltdl'.  Make sure you start DIR with
# '${top_builddir}/' (note the single quotes!) if your package is not
# flat, and, if you're not using automake, define top_builddir as
# appropriate in the Makefiles.
# In the future, this macro may have to be called after AC_PROG_LIBTOOL.
AC_DEFUN(AC_LIBLTDL_INSTALLABLE, [AC_BEFORE([$0],[AC_LIBTOOL_SETUP])dnl
  AC_CHECK_LIB(ltdl, main,
  [test x"$enable_ltdl_install" != xyes && enable_ltdl_install=no],
  [if test x"$enable_ltdl_install" = xno; then
     AC_MSG_WARN([libltdl not installed, but installation disabled])
   else
     enable_ltdl_install=yes
   fi
  ])
  if test x"$enable_ltdl_install" = x"yes"; then
    ac_configure_args="$ac_configure_args --enable-ltdl-install"
    LIBLTDL=ifelse($#,1,$1,['${top_builddir}/libltdl'])/libltdl.la
    INCLTDL=ifelse($#,1,-I$1,['-I${top_builddir}/libltdl'])
  else
    ac_configure_args="$ac_configure_args --enable-ltdl-install=no"
    LIBLTDL="-lltdl"
    INCLTDL=
  fi
])

dnl old names
AC_DEFUN(AM_PROG_LIBTOOL, [indir([AC_PROG_LIBTOOL])])dnl
AC_DEFUN(AM_ENABLE_SHARED, [indir([AC_ENABLE_SHARED], $@)])dnl
AC_DEFUN(AM_ENABLE_STATIC, [indir([AC_ENABLE_STATIC], $@)])dnl
AC_DEFUN(AM_DISABLE_SHARED, [indir([AC_DISABLE_SHARED], $@)])dnl
AC_DEFUN(AM_DISABLE_STATIC, [indir([AC_DISABLE_STATIC], $@)])dnl
AC_DEFUN(AM_PROG_LD, [indir([AC_PROG_LD])])dnl
AC_DEFUN(AM_PROG_NM, [indir([AC_PROG_NM])])dnl

dnl This is just to silence aclocal about the macro not being used
ifelse([AC_DISABLE_FAST_INSTALL])dnl

