/*                                                                  |- CFSFC -|
 * The contents of this file are subject to the Mozilla
 * Public License Version 1.0 (the "License"); you may
 * not use this file except in compliance with the
 * License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/ 
 *
 * Software distributed under the License is distributed
 * on an "AS IS" basis, WITHOUT WARRANTY OF
 * ANY KIND, either express or implied. See the
 * License for the specific language governing rights
 * and limitations under the License. 
 *
 * The Original Code is Copyright (C) 1998 Andrew Hunter.
 * All Rights Reserved. 
 *
 * The Initial Developer of the Original Code is
 * Andrew Hunter.
 *
 * Contributor(s):
 * No-one (yet :-)
 */

/*
 * screen.h
 * --------
 *
 * Drawable implementation for screens
 */

#ifndef __impulse_rows_screen_h
#define __impulse_rows_screen_h

#include <impulse/rows/drawable.h>
#include <impulse/rows/child.h>
#include <impulse/rows/colour.h>

/*                            ======--------======                           */

/* Drawable widget type */

typedef void **ROWS_screen;

/*                            ======--------======                           */

/* Standard widget functions */

extern ROWS_widget ROWS_screen_create(ROWS_child child);
extern ROWS_widget *ROWS_screen_initialise(int id,
					   ROWS_child child);
extern inline int ROWS_screen_next_identifier(void);
extern inline ROWS_screen ROWS_screen_cast(void **widget);


/*                            ======--------======                           */

/* Widget-specific functions */
extern void ROWS_screen_set_default_gamut(ROWS_gamut gamut);

#endif
